import * as ng from '@angular/compiler-cli';
import ts from 'typescript';
export interface CompileArgs {
    rootNames: string[];
    compilerHost: ng.CompilerHost;
    compilerOptions: ng.CompilerOptions;
    oldProgram?: ng.Program;
}
export interface CacheEntry {
    exists?: boolean;
    sf?: ts.SourceFile;
    content?: string;
}
export interface RecompileResult extends ng.PerformCompilationResult {
    recompiledFiles: string[];
}
export declare type RecompileFunctionAsync = (fileName: string) => Promise<RecompileResult>;
/**
 * Based on `@angular/compiler-cli.performCompilation()`
 */
export declare const performCompilationAsync: ({ compilerHost, compilerOptions, rootNames, oldProgram }: CompileArgs, typeCheck?: boolean) => Promise<ng.PerformCompilationResult>;
export declare const compileAsync: ({ rootNames, compilerHost, compilerOptions, }: CompileArgs) => Promise<ng.PerformCompilationResult>;
export declare const watchCompileAsync: ({ rootNames, compilerHost, compilerOptions, }: CompileArgs) => Promise<{
    firstCompilation: ng.PerformCompilationResult;
    recompile: RecompileFunctionAsync;
}>;
export declare const getProjectPackageImports: (rootNames: string[], options: ng.CompilerOptions) => Set<string>;
