import { AngularJsonWrapper } from './configParser';
import * as ng from '@angular/compiler-cli';
import { SnowpackConfig } from 'snowpack';
interface BuiltJSFile {
    code: string;
    map?: string;
}
declare type TypeCheckErrorListener = (diagnostic: ng.Diagnostics) => void;
export declare class AngularCompilerService {
    private ngccTargets;
    private snowpackConfig;
    private angularProject?;
    private _angularConfig;
    private _ngCompilerHost;
    private _ngConfiguration;
    private get _ngCompilerOptions();
    private _builtFiles;
    private _buildStatus;
    private _recompileFunction?;
    private _lastCompilationResult?;
    private _typeCheckErrorListeners;
    private _typeCheckErrorListenerId;
    private _typeCheckWorker?;
    private _lastTypeCheckResult;
    private _fileReplacements;
    private _cwd;
    private _tsConfig;
    private _isWatch;
    constructor(angularJson: string, ngccTargets: string[], snowpackConfig: SnowpackConfig, angularProject?: string | undefined);
    private ngcc;
    private configureCompilerHost;
    private registerTypeCheckWorker;
    buildSource(watch: boolean): Promise<void>;
    recompile(modifiedFile: string): Promise<{
        recompiledFiles: string[];
        recompiledResult: import("./compile").RecompileResult;
    }>;
    getBuiltFile(filePath: string): BuiltJSFile | null;
    onTypeCheckError(listener: TypeCheckErrorListener): number;
    removeTypeCheckErrorListener(id: number): void;
    getIndexInjects(): {
        injectPolyfills: string;
        injectMain: string;
        injectStyles: string[];
        injectScripts: string[];
    };
    getErrorInFile(filePath: string): ng.Diagnostics;
    getErroredFiles(diagnostics: ng.Diagnostics): string[];
    formatDiagnostics(diagnostics: ng.Diagnostics): string;
    get ngConfiguration(): ng.ParsedConfiguration;
    get angularConfig(): AngularJsonWrapper;
    getAngularCriticalFiles(): import("./configParser").AngularCriticalFiles;
    useSourceMaps(state?: 'normal' | 'none' | 'inline', inlineSources?: boolean): void;
}
export {};
