export interface fileReplacement {
    replace: string;
    with: string;
}
export interface AngularArchitectConfig {
    fileReplacements: fileReplacement[];
    optimization: boolean;
    sourceMap: boolean;
}
export interface AngularArchitectSubset {
    options: {
        outputPath: string;
        index: string;
        main: string;
        polyfills: string;
        tsConfig: string;
        aot: boolean;
        assets: string[];
        styles: string[];
        scripts: string[];
    };
    configurations: {
        [configurationName: string]: AngularArchitectConfig;
    };
}
export interface AngularProjectSubset {
    sourceRoot: string;
    architect: {
        [architectName: string]: AngularArchitectSubset;
    };
}
export interface AngularJson {
    projects: {
        [projectName: string]: AngularProjectSubset;
    };
    defaultProject: string;
}
export interface AngularCriticalFiles {
    index: string;
    polyfills: string;
    main: string;
    styles: string[];
    scripts: string[];
    tsConfig: string;
}
export interface AngularJsonWrapper {
    angularJson: AngularJson;
    getProject: (projectName?: string) => AngularProjectSubset;
    getResolvedFilePaths: (projectName?: string) => AngularCriticalFiles;
}
export declare const readAngularJson: (fileName: string) => AngularJsonWrapper;
