"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readAngularJson = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
exports.readAngularJson = (fileName) => {
    const jsonContents = JSON.parse(fs_1.default.readFileSync(fileName, 'utf-8'));
    return {
        angularJson: jsonContents,
        getProject(projectName) {
            if (!projectName)
                projectName = this.angularJson.defaultProject;
            return this.angularJson.projects[projectName];
        },
        getResolvedFilePaths(projectName) {
            const project = this.getProject(projectName);
            return {
                index: path_1.default.resolve(project.architect.build.options.index),
                polyfills: path_1.default.resolve(project.architect.build.options.polyfills),
                main: path_1.default.resolve(project.architect.build.options.main),
                styles: project.architect.build.options.styles.map((style) => path_1.default.resolve(style)),
                scripts: project.architect.build.options.scripts.map((script) => path_1.default.resolve(script)),
                tsConfig: project.architect.build.options.tsConfig,
            };
        },
    };
};
