#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const snowpack_1 = require("snowpack");
const path_1 = __importDefault(require("path"));
const styleResource_1 = require("./styleResource");
/**
 * The reason a wrapper code is needed for preprocess to work in dev mode is mainly because
 * Snowpack does NOT fully build a file if the browser does not request for it,
 * eg: the plugin can wait for `app.component.scss` at `transform()` forever but it will never be resolved unless the browser requested `app.component.scss`
 *
 * By using a simple wrapper for the snowpack dev server and communicating with the plugin, it is possible to trigger the above "browser request" behavior
 */
const devMain = async () => {
    const config = await snowpack_1.loadConfiguration({}, path_1.default.resolve(process.cwd(), 'snowpack.config.js'));
    styleResource_1.styleResourceManager.on('request', async (stylePath) => {
        const finalResourceUrl = server.getUrlForFile(stylePath);
        server.loadUrl(finalResourceUrl);
    });
    const server = await snowpack_1.startServer({ config, lockfile: null });
};
devMain();
