"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tsFormatDiagnosticHost = exports.getTSDiagnosticErrorInFile = exports.getTSDiagnosticErrorFile = exports.runTypeCheck = exports.isTemplateDiagnostic = void 0;
const ng = __importStar(require("@angular/compiler-cli"));
const ts = __importStar(require("typescript"));
const path_1 = __importDefault(require("path"));
exports.isTemplateDiagnostic = (diagnostic) => {
    return (diagnostic.hasOwnProperty('componentFile') &&
        ts.isSourceFile(diagnostic.componentFile));
};
exports.runTypeCheck = (rootNames, options, program, host) => {
    const diagnostics = [];
    try {
        if (!program) {
            if (!host)
                host = ng.createCompilerHost({ options });
            program = ng.createProgram({
                rootNames,
                host,
                options,
            });
        }
        diagnostics.push(...ng.defaultGatherDiagnostics(program));
        // No errors
        return diagnostics;
    }
    catch (e) {
        let errMsg;
        let code;
        if (e['ngSyntaxError']) {
            // don't report the stack for syntax errors as they are well known errors.
            errMsg = e.message;
            code = ng.DEFAULT_ERROR_CODE;
        }
        else {
            errMsg = e.stack;
            // It is not a syntax error we might have a program with unknown state, discard it.
            code = ng.UNKNOWN_ERROR_CODE;
        }
        diagnostics.push({
            category: ts.DiagnosticCategory.Error,
            messageText: errMsg,
            code,
            source: ng.SOURCE,
        });
        return diagnostics;
    }
};
exports.getTSDiagnosticErrorFile = (diagnostics) => {
    const tsDiagnostics = diagnostics.filter((diagnostic) => ng.isTsDiagnostic(diagnostic));
    return tsDiagnostics.map((diagnostic) => path_1.default.resolve(exports.isTemplateDiagnostic(diagnostic)
        ? diagnostic.componentFile.fileName
        : diagnostic.file.fileName));
};
exports.getTSDiagnosticErrorInFile = (filePath, diagnostics) => {
    const tsErrors = diagnostics.filter((diagnostic) => ng.isTsDiagnostic(diagnostic));
    return tsErrors.filter((error) => path_1.default.resolve(exports.isTemplateDiagnostic(error)
        ? error.componentFile.fileName
        : error.file.fileName) === path_1.default.resolve(filePath));
};
exports.tsFormatDiagnosticHost = {
    getCanonicalFileName: (fileName) => fileName,
    getCurrentDirectory: () => path_1.default.resolve(process.cwd()),
    getNewLine: () => '\n',
};
