"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypeCheckWorker = void 0;
const worker_threads_1 = __importDefault(require("worker_threads"));
const typeCheck_1 = require("./typeCheck");
exports.createTypeCheckWorker = () => {
    const typeCheckWorker = new worker_threads_1.default.Worker(__filename);
    return typeCheckWorker;
};
const runWorker = () => {
    worker_threads_1.default.parentPort.on('message', ({ action, data }) => {
        switch (action) {
            case 'run_check':
                worker_threads_1.default.parentPort.postMessage(typeCheck_1.runTypeCheck(data.rootNames, data.options));
                break;
        }
    });
};
if (!worker_threads_1.default.isMainThread)
    runWorker();
